算法题(203):矩阵最小路径和

审题:

本题需要我们从(1,1)出发,然后通过各种路径走到(n,m)点,并找出所有路径中路径和最小的总和值

思路:
方法一:动态规划

**(1)状态表示:**fij表示从(1,1)到达点(i,j)时所有路径中路径和最小的路径值

**(2)状态转移方程:**由于题目中的移动规则是可以向右和向下移动,所以我们的转移方程也是分两种的

图示:

第一种:向下移动

路径和是当前节点的值加上前一个节点的路径总和,即(i-1,j)点的f值加当前节点的值

第二种:向右移动

同理,由(i,j-1)的f值加当前节点的值

(3)初始化:有两个特殊处理

首先,为了确保f11正确初始化为x11,我们的f01/f10至少有一个初始化为0

图示:

其次,为了防止无效位置妨碍边缘节点的判断,我们的边缘无效位置需要初始化为一个不可能计入最短路径的值,也就是一个max值(0x3f3f3f3f)

图示:

(4)填表顺序:从上到下,从左到右

因为我们某个节点的f需要根据其左方和上方的f求,所以一定要先将上方和左方的f先计算出来

(5)答案输出:直接输出fnm即可

解题:

cpp 复制代码
#include<iostream>
#include<cstring>
using namespace std;
const int N = 510;
int n, m;
int x[N][N], f[N][N];
int main()
{
	//数据录入
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			cin >> x[i][j];
		}
	}
	//初始化
	memset(f, 0x3f3f3f3f, sizeof f);
	f[1][0] = 0;
	//填dp表
	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; j <= m; j++)
		{
			f[i][j] = min(f[i - 1][j], f[i][j - 1]) + x[i][j];
		}
	}
	//输出数据
	cout << f[n][m] << endl;
	return 0;
}

memset需要包含cstring头文件才可以使用

矩阵的最小路径和_牛客题霸_牛客网

相关推荐
UIU1144 小时前
P1233 [ICPC 2001 Taejon R] 木棍加工
数据结构·c++·算法·动态规划
论文复现现场5 小时前
WRF、FEA 能用 L40S 加速吗?求解器检查、断点恢复与长期运行
java·数据库·算法·wrf·有限元分析·gpu计算·断点续算
ZhengEnCi5 小时前
用 AI 写代码为什么拼到最后还是拼人:算力瓶颈与领域专家提示词的本质差异
算法·架构
秋天的怀念_David6 小时前
第二十一夜 · 数字黑洞与西西弗斯的惩罚
java·程序人生·算法
碧海银沙音频科技研究院7 小时前
在PC电脑上用Whisper→Marian算法实现离线语音翻译功能
算法·whisper
niyongsheng7 小时前
3D 装箱算法工程化:数据结构、放置启发式与支撑规则
数据结构·算法·rust
j7~9 小时前
【穷举、深搜与回溯算法】一棵决策树讲透全排列与子集
数据结构·c++·算法·leetcode·回溯·递归
傅科摆 _ py10 小时前
DP,贪心,堆和栈,二分力扣复习
开发语言·python·算法
Shaoshing11 小时前
LeetCode100 42.接雨水
java·算法·leetcode
域限奇点访客11 小时前
用AI生成问卷的网站怎么选?看题目录入结构、题型映射和生成后的校验
算法